Package: methylGSA
Type: Package
Title: Gene Set Analysis Using the Outcome of Differential Methylation
Version: 1.31.0
Authors@R: c(
    person("Xu", "Ren", 
        email = "xuren2120@gmail.com", role = c("aut", "cre")),
    person("Pei Fen", "Kuan", 
        email = "peifen.kuan@stonybrook.edu", role = "aut"))
Description: The main functions for methylGSA are methylglm and methylRRA.
    methylGSA implements logistic regression adjusting number of probes as 
    a covariate.
    methylRRA adjusts multiple p-values of each gene by Robust Rank Aggregation.
    For more detailed help information, please see the vignette.
Encoding: UTF-8
Imports: RobustRankAggreg, ggplot2, stringr, stats, clusterProfiler,
        missMethyl, org.Hs.eg.db, reactome.db, BiocParallel, GO.db,
        AnnotationDbi, shiny,
        IlluminaHumanMethylation450kanno.ilmn12.hg19,
        IlluminaHumanMethylationEPICanno.ilm10b4.hg19
Depends: R (>= 3.5)
Suggests: knitr, rmarkdown, testthat, enrichplot
License: GPL-2
URL: https://github.com/reese3928/methylGSA
BugReports: https://github.com/reese3928/methylGSA/issues
RoxygenNote: 6.1.0
VignetteBuilder: knitr
biocViews:
        DNAMethylation,DifferentialMethylation,GeneSetEnrichment,Regression,
        GeneRegulation,Pathways
git_url: https://git.bioconductor.org/packages/methylGSA
git_branch: devel
git_last_commit: 7792ec0
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-05-11
NeedsCompilation: no
Packaged: 2026-05-11 22:45:46 UTC; biocbuild
Author: Xu Ren [aut, cre],
  Pei Fen Kuan [aut]
Maintainer: Xu Ren <xuren2120@gmail.com>

methylGSA
===========

`methylGSA` is a Bioconductor package and Shiny app for DNA methylation data length bias adjustment in gene set testing. 

The Bioconductor package can be found [here](https://bioconductor.org/packages/release/bioc/html/methylGSA.html).    
The Bioconductor package vignette can be found [here](https://bioconductor.org/packages/release/bioc/vignettes/methylGSA/inst/doc/methylGSA-vignette.html).   
The `methylGSA` paper can be found [here](https://doi.org/10.1093/bioinformatics/bty892).

Shiny app installation
------------
The following packages are required to be installed before launching the app.    
Packages from CRAN:
```{r}    
install.packages("DT")    
install.packages("ggplot2")       
install.packages("shinycssloaders")     
```

Packages from Bioconductor:    
If analyzing 450K array, `IlluminaHumanMethylation450kanno.ilmn12.hg19` needs to be installed.
```{r}
if (!requireNamespace("BiocManager", quietly = TRUE)) install.packages("BiocManager")
BiocManager::install("IlluminaHumanMethylation450kanno.ilmn12.hg19")
```
If analyzing EPIC array, `IlluminaHumanMethylationEPICanno.ilm10b4.hg19` needs to be installed.
```{r}
if (!requireNamespace("BiocManager", quietly = TRUE)) install.packages("BiocManager")
BiocManager::install("IlluminaHumanMethylationEPICanno.ilm10b4.hg19")
```

Launch the app
------------
After installation, the app can be launched with the following code:
```{r}
library(methylGSA)
methylGSA::runExample()
```

Step-by-step instructions
------------
A step-by-step instructions on the workflow of the app can be found [here](https://github.com/reese3928/methylGO-RShiny-app/raw/master/instructions.pdf).

Citation
------------
Ren, X., & Kuan, P. F. (2019). methylGSA: a Bioconductor package and Shiny app for DNA methylation data length bias adjustment in gene set testing. Bioinformatics, 35(11), 1958-1959.

@article{ren2019methylgsa,    
title={methylGSA: a Bioconductor package and Shiny app for DNA methylation data length bias adjustment in gene set testing},    
author={Ren, Xu and Kuan, Pei Fen},    
journal={Bioinformatics},    
volume={35},    
number={11},    
pages={1958--1959},    
year={2019},    
publisher={Oxford University Press}    
}

library(shinycssloaders)
ui <- navbarPage("methylGSA",
                 tabPanel("Main",
                          # Sidebar with a slider input for number of bins 
                          sidebarLayout(
                              sidebarPanel(
                                  HTML("Please upload CpG IDs and their p-values. See help page for instructions." 
                                  ),
                                  
                                  fileInput(inputId = "cpg.pval", 
                                            label = ""),
                                  
                                  fluidRow(
                                      column(6, 
                                             selectInput(inputId = "array.type", 
                                                         label = "Array type:",
                                                         choices = c("450K", "EPIC"), 
                                                         selected = "450K")
                                      ),
                                      column(6,
                                             selectInput(inputId = "group", 
                                                         label = "Group:",
                                                         choices = c("all", "body", "promoter1", "promoter2"), 
                                                         selected = "all")
                                      )
                                  ),
                                  
                                  selectInput(inputId = "GS.list", 
                                              label = "Gene sets tested:",
                                              choices = c("Gene Ontology" = "GO", "KEGG", "Reactome"), 
                                              selected = "GO"),
                                  
                                  sliderInput(inputId = "minsize", 
                                              label = "Minimum gene set size:",
                                              min = 0, max = 1000, value = 100, step = 10), 
                                  
                                  sliderInput(inputId = "maxsize", 
                                              label = "Maximum gene set size:",
                                              min = 0, max = 1000, value = 500, step = 10), 
                                  
                                  selectInput(inputId = "test.method", 
                                              label = "Test method:",
                                              choices = c("methylglm", "gometh", "RRA(ORA)", "RRA(GSEA)"), 
                                              selected = "methylglm"),
                                  
                                  actionButton("go","GO!")
                                  
                                  #HTML("Please note, it may take some time for the results to show up.")
                                  
                              ),
                              
                              
                              mainPanel(
                                  htmlOutput("restext"),
                                  tabsetPanel(type = "tabs",
                                              tabPanel("Table",
                                                       withSpinner(DT::dataTableOutput("resTable"), type = 8),
                                                       downloadButton('download1',"Download as csv"),
                                                       downloadButton('download2',"Download as txt"),
                                                       tags$head(tags$style("#restext{font-size: 25px;}"))),
                                              tabPanel("Plot",
                                                       fluidRow(
                                                           column(4, 
                                                                  numericInput(inputId = "ngs",
                                                                               label = "Number of gene sets to display:",
                                                                               value = 5,
                                                                               min = 1,
                                                                               max = NA)
                                                           ),
                                                           column(4,
                                                                  selectInput(inputId = "xaxis", 
                                                                              label = "x-axis:",
                                                                              choices = c("Number of significant genes" = "Count", "Total genes" = "Size"), 
                                                                              selected = "Size")
                                                           ),
                                                           column(4,
                                                                  selectInput(inputId = "colorby", 
                                                                              label = "Color by:",
                                                                              choices = c("Adjusted p-value" = "padj", "Raw p-value" = "pvalue"), 
                                                                              selected = "padj")
                                                                  
                                                           )
                                                         
                                                       ),
                                                       plotOutput("resPlot"),
                                                       downloadButton('downloadPlot1',"Download as pdf"),
                                                       downloadButton('downloadPlot2',"Download as png")
                                                       
                                              )
                                  )
                                  
                              )
                              
                              
                          )
                 ),
                 
                 tabPanel("Help",
                          fluidRow(
                              column(8,
                                     includeMarkdown("instructions.md")
                              )
                          )
                          
                 ),
                 
                 tabPanel("About",
                          fluidRow(
                              column(6,
                                     includeMarkdown("About.md")
                              )
                              
                          )
                          
                 )
                 
)

#' @title Implement logistic regression adjusting
#' for number of probes in enrichment analysis
#'
#' @description This function implements logistic regression adjusting
#' for number of probes in enrichment analysis.
#' @param cpg.pval A named vector containing p-values of differential
#' methylation test. Names should be CpG IDs.
#' @param array.type A string. Either "450K" or "EPIC". Default is "450K".
#' This argument will be ignored if FullAnnot is provided.
#' @param FullAnnot A data frame provided by prepareAnnot function.
#' Default is NULL.
#' @param group A string. "all", "body", "promoter1" or "promoter2". 
#' Default is "all". If group = "body", only CpGs on gene body will be 
#' considered in methylglm. If group = "promoter1" or group = "promoter2", 
#' only CpGs on promoters will be considered. Here is the definition of "body", 
#' "promoter1" and "promoter2" according to the annotation in 
#' IlluminaHumanMethylation450kanno.ilmn12.hg19 or 
#' IlluminaHumanMethylationEPICanno.ilm10b4.hg19. 
#' \itemize{
#'   \item body: CpGs whose gene group correspond to "Body" or "1stExon" 
#'   \item promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
#'   \item promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
#'   "1stExon", or "5'UTR". 
#' }
#' If group = "all", all CpGs are considered regardless of their gene group.
#' @param GS.list A list. Default is NULL. If there is no input list,
#' Gene Ontology is used. Entry names are gene sets names, and elements
#' correpond to genes that gene sets contain.
#' @param GS.idtype A string. "SYMBOL", "ENSEMBL", "ENTREZID" or "REFSEQ".
#' Default is "SYMBOL"
#' @param GS.type A string. "GO", "KEGG", or "Reactome". Default is "GO"
#' @param minsize An integer. If the number of genes in a gene set is
#' less than this integer, this gene set is not tested. Default is 100.
#' @param maxsize An integer. If the number of genes in a gene set is greater
#' than this integer, this gene set is not tested. Default is 500.
#' @param parallel either TRUE or FALSE indicating whether parallel should be
#' used. Default is FALSE
#' @param BPPARAM an argument provided to \code{\link{bplapply}}. See
#' \code{\link[BiocParallel]{register}} for details.
#' @details The implementation of this function is modified from goglm
#' function in GOglm package.
#' @export
#' @import stats
#' @import org.Hs.eg.db
#' @importFrom AnnotationDbi select
#' @importFrom BiocParallel bplapply bpparam
#' @return A data frame contains gene set tests results.
#' @references Mi G, Di Y, Emerson S, Cumbie JS and Chang JH (2012)
#' Length bias correction in Gene Ontology enrichment analysis using
#' logistic regression. PLOS ONE, 7(10): e46128
#' @references Phipson, B., Maksimovic, J., and Oshlack, A. (2015).
#' missMethyl: an R package for analysing methylation data from Illuminas
#' HumanMethylation450 platform. Bioinformatics, btv560.
#' @references Carlson M (2017). org.Hs.eg.db: Genome wide annotation for
#' Human. R package version 3.5.0.
#' @examples
#' data(CpG2Genetoy)
#' data(cpgtoy)
#' data(GSlisttoy)
#' GS.list = GS.list[1:10]
#' FullAnnot = prepareAnnot(CpG2Gene)
#' res = methylglm(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
#' GS.list = GS.list, GS.idtype = "SYMBOL")
#' head(res)

methylglm <- function(cpg.pval, array.type = "450K", FullAnnot = NULL,
                            group = "all", GS.list=NULL, GS.idtype = "SYMBOL", 
                            GS.type = "GO", minsize = 100, maxsize = 500,
                            parallel = FALSE, BPPARAM = bpparam()){
    if(!is.vector(cpg.pval)|!is.numeric(cpg.pval)|is.null(names(cpg.pval))){
        stop("Input CpG pvalues should be a named vector")
    }
    if(sum(cpg.pval==0)>0){
        stop("Input CpG pvalues should not contain 0")
    }
    if(!is.list(GS.list)&!is.null(GS.list)){
        stop("Input gene sets should be a list")
    }
    
    GS.idtype = match.arg(
        GS.idtype,c("SYMBOL", "ENSEMBL", "ENTREZID", "REFSEQ"))
    if(!is.null(GS.list) & GS.idtype!="SYMBOL"){
        GS.list = suppressMessages(lapply(GS.list, function(x)
            select(org.Hs.eg.db, x, columns = "SYMBOL", 
                keytype = GS.idtype)$SYMBOL))
    }
    GS.type = match.arg(GS.type, c("GO", "KEGG", "Reactome"))
    group = match.arg(group, c("all", "body", "promoter1", "promoter2"))
    
    stopifnot(length(minsize)==1)
    if(!is.numeric(minsize) | minsize<0){
        stop("minsize should be a positive number")
    }
    stopifnot(length(maxsize)==1)
    if(!is.numeric(maxsize) | maxsize<0){
        stop("maxsize should be a positive number")
    }
    if(maxsize<minsize){
        stop("maxsize should be greater than minsize")
    }
    
    stopifnot(length(parallel)==1)
    if(!is.logical(parallel)){
        stop("parallel should be either TRUE or FALSE")
    }

    if(is.null(FullAnnot)){
        stopifnot(length(array.type)==1)
        if(array.type!="450K" & array.type!="EPIC"){
            stop("Input array type should be either 450K or EPIC")
        }
        if(array.type=="450K"){
            FullAnnot = getAnnot("450K", group)
        }else{
            FullAnnot = getAnnot("EPIC", group)
        }
    }

    cpg.intersect = intersect(names(cpg.pval), rownames(FullAnnot))
    cpg.pval = cpg.pval[cpg.intersect]
    FullAnnot.sub = FullAnnot[names(cpg.pval), ]
    ## match user input CpG to our FullAnnot database
    names(cpg.pval) = FullAnnot.sub$UCSC_RefGene_Name
    ## change CpG ids to gene symbols
    geneID.list = split(cpg.pval, names(cpg.pval))
    ## convert cpg.pval to a list, each element of this
    #list is a gene and it's corresponding cpg pvalue
    gene.pval = vapply(geneID.list, min, FUN.VALUE = 1)
    ## for each gene, take the minimum p-value
    probes = vapply(geneID.list, length, FUN.VALUE = 1)
    ## get number of probes for each gene
    
    flag = 0
    if(is.null(GS.list)){
        GS.list = getGS(names(geneID.list), GS.type = GS.type)
        flag = 1
    }
    
    GS.list = lapply(GS.list, na.omit)

    GS.sizes = vapply(GS.list, length, FUN.VALUE = 1)
    GS.list.sub = GS.list[GS.sizes>=minsize & GS.sizes<=maxsize]
    ## filter gene sets by their sizes
    
    if(!parallel){
        message(length(GS.list.sub), " gene sets are being tested...")
    }else{
        numworkers = BPPARAM$workers
        if(!numworkers[[1]]){
            numworkers = 1
        }
        message(length(GS.list.sub), " gene sets are being tested... using ",
            numworkers, " workers.")
    }
    
    glmFit = function(i){
        gs = GS.list.sub[[i]]
        y = as.numeric(names(gene.pval)%in%gs)
        df = data.frame(NegLogP = -log(gene.pval), probes = log(probes), y = y)
        glm.fit = glm(y ~ NegLogP + probes, family = "quasibinomial",
            data = df, control = list(maxit = 25))
        sumry = summary(glm.fit)
        sign(coefficients(glm.fit)[[2]])*sumry$coef[ ,"Pr(>|t|)"][[2]]
    }
    if(parallel){
        temp = bplapply(seq_along(GS.list.sub), glmFit, BPPARAM = BPPARAM)
        gs.pval = vapply(temp, function(x) x[1], 1)
    }else{
        gs.pval = vapply(seq_along(GS.list.sub), glmFit, 1)
    }
    gs.pval[gs.pval<=0] = 1
    ID = names(GS.list.sub)
    size = vapply(GS.list.sub, length, FUN.VALUE = 1)

    gs.padj = p.adjust(gs.pval, method = "BH")
    if(flag==1){
        des = getDescription(GSids = ID, GS.type = GS.type)
        res = data.frame(ID = ID, Description = des, Size = size,
            pvalue = gs.pval, padj = gs.padj)
    }else{
        res = data.frame(ID = ID, Size = size, pvalue = gs.pval, padj = gs.padj)
    }
        
    rownames(res) = ID
    res = res[order(res$pvalue),]
    message("Done!")
    return(res)
}

context("Test function output")

data(CpG2Genetoy)
data(cpgtoy)
data(GSlisttoy)
GS.list = GS.list[1:10]
FullAnnot = prepareAnnot(CpG2Gene)

test_that("check for valid output", {
    res1 = methylglm(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
                     GS.list = GS.list, GS.idtype = "SYMBOL",
                     minsize = 100, maxsize = 300)
    expect_is(res1, 'data.frame')
    expect_equal(dim(res1)[2], 4)
    expect_true(all(res1$pvalue>=0 & res1$pvalue<=1))
    expect_true(all(res1$padj>=0 & res1$padj<=1))
    expect_true(all(colnames(res1) %in% c("ID", "Size", "pvalue", "padj")))

    res2 = methylRRA(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
                     method = "ORA", GS.list = GS.list)
    expect_is(res2, 'data.frame')
    expect_equal(dim(res2)[2], 5)
    expect_true(all(res2$pvalue>=0 & res2$pvalue<=1))
    expect_true(all(res2$padj>=0 & res2$padj<=1))
    expect_true(all(colnames(res2) %in% c("ID", "Count", 
                                          "Size", "pvalue", "padj")))

    res3 = methylRRA(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
                     method = "GSEA", GS.list = GS.list)
    expect_is(res3, 'data.frame')
    expect_equal(dim(res3)[2], 8)
    expect_true("core_enrichment"%in%colnames(res3))
    expect_true(all(res3$pvalue>=0 & res3$pvalue<=1))
    expect_true(all(res3$p.adjust>=0 & res3$p.adjust<=1))
    expect_true(all(colnames(res3) %in%
                        c("ID","Size","enrichmentScore",
                          "NES","pvalue","padj","leading_edge",
                          "core_enrichment")))
})

context("Test user input")

data(cpgtoy)
data(GSlisttoy)

test_that("Invalid cpg pvalue input", {
    df = data.frame(cpgID = names(cpg.pval), pval = cpg.pval)

    expect_error(methylglm(cpg.pval = df))
    expect_error(methylgometh(cpg.pval = df, sig.cut = 0.001))
    expect_error(methylRRA(cpg.pval = df))
    expect_error(methylRRA(cpg.pval = runif(1000)))

    cpg.pval[1:10] = 0
    expect_error(methylgometh(cpg.pval = cpg.pval, sig.cut = 0.001))
    expect_error(methylRRA(cpg.pval = cpg.pval))
    expect_error(methylRRA(cpg.pval = cpg.pval))

})

test_that("Invalid GS.list input", {
    df = data.frame(
        GS = c(rep("GS1", length(GS.list[[1]])),
               rep("GS2", length(GS.list[[2]])),
               rep("GS3", length(GS.list[[3]]))
               ),
        gene = c(GS.list[[1]], GS.list[[2]], GS.list[[3]]))

    expect_error(methylglm(cpg.pval = cpg.pval, GS.list = df))
    expect_error(methylRRA(cpg.pval = cpg.pval, GS.list = df))
    expect_error(methylgometh(cpg.pval = cpg.pval,
                              sig.cut = 0.01, GS.list = df))
})


test_that("Invalid sig.cut", {
    expect_error(methylgometh(cpg.pval = cpg.pval, sig.cut = 1))
    expect_error(methylgometh(cpg.pval = cpg.pval, sig.cut = 0))
    expect_error(methylgometh(cpg.pval = cpg.pval, sig.cut = 10))
    expect_error(methylgometh(cpg.pval = cpg.pval, sig.cut = -1))
})

#' @title Get CpG annotation
#'
#' @description This function gets CpG IDs and their corresponding gene symbols.
#' @param array.type A string. Either "450K" or "EPIC". Default is "450K".
#' @param group A string. "all", "body", "promoter1" or "promoter2". 
#' Default is "all". If group = "body", only CpGs on gene body will be 
#' pulled out. If group = "promoter1" or group = "promoter2", 
#' only CpGs on promoters will be pulled out. Here is the definition of "body", 
#' "promoter1" and "promoter2" according to the annotation in 
#' IlluminaHumanMethylation450kanno.ilmn12.hg19 or 
#' IlluminaHumanMethylationEPICanno.ilm10b4.hg19. 
#' \itemize{
#'   \item body: CpGs whose gene group correspond to "Body" or "1stExon" 
#'   \item promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
#'   \item promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
#'   "1stExon", or "5'UTR". 
#' }
#' If group = "all", all CpGs will be pulled out.
#' @import IlluminaHumanMethylation450kanno.ilmn12.hg19
#' @import IlluminaHumanMethylationEPICanno.ilm10b4.hg19
#' @importFrom stringr str_length
#' @details The implementation of the function is modified
#' from .flattenAnn function in missMethyl package.
#' @return A data frame contains CpG IDs and gene symbols.
#' @references Hansen KD (2016). IlluminaHumanMethylation450kanno.ilmn12.hg19:
#' Annotation for Illumina's 450k methylation arrays. R package version 0.6.0.
#' @references Hansen KD (2017). IlluminaHumanMethylationEPICanno.ilm10b4.hg19:
#' Annotation for Illumina's EPIC methylation arrays. R package version 0.6.0,
#' https://bitbucket.com/kasperdanielhansen/Illumina_EPIC.
#' @references Phipson B, Maksimovic J and Oshlack A (2015).
#' “missMethyl: an R package for analysing methylation data from
#' Illuminas HumanMethylation450 platform.” Bioinformatics, pp. btv560.

getAnnot = function(array.type, group = "all"){
    if(array.type=="450K"){
        FullAnnot = tryCatch({
            getAnnotation(IlluminaHumanMethylation450kanno.ilmn12.hg19)
            },
            error = function(e){
                stop("IlluminaHumanMethylation450kanno.ilmn12.hg19 needs to
be installed and loaded before running methylglm/methylRRA")
            })
    }else{
        FullAnnot = tryCatch({
            getAnnotation(IlluminaHumanMethylationEPICanno.ilm10b4.hg19)
        },
        error = function(e){
            stop("IlluminaHumanMethylationEPICanno.ilm10b4.hg19 needs to
be installed and loaded before running methylglm/methylRRA")
        })
    }
        
    FullAnnot = FullAnnot[,c("Name","UCSC_RefGene_Name","UCSC_RefGene_Group")]
    FullAnnot = FullAnnot[str_length(rownames(FullAnnot))==10,]
    FullAnnot = FullAnnot[!FullAnnot$UCSC_RefGene_Name=="",]
    ## get the first gene in each USCS_RefGene_Name
    temp = vapply(strsplit(FullAnnot$UCSC_RefGene_Name,split=";"),
                        '[', 1, FUN.VALUE=character(1))
    FullAnnot$UCSC_RefGene_Name = temp
    ## get the first gene group in each UCSC_RefGene_Group
    temp = vapply(strsplit(FullAnnot$UCSC_RefGene_Group,split=";"),
        '[', 1, FUN.VALUE=character(1))
    FullAnnot$UCSC_RefGene_Group = temp
    
    if(group == "body"){
        FullAnnot = 
            FullAnnot[FullAnnot$UCSC_RefGene_Group%in%c("Body", "1stExon"),]
    }
        
    if(group == "promoter1"){
        FullAnnot = FullAnnot[grepl("TSS",FullAnnot$UCSC_RefGene_Group),]
    }
    
    if(group == "promoter2"){
        FullAnnot = 
            FullAnnot[FullAnnot$UCSC_RefGene_Group%in%c("TSS200", "TSS1500", 
                "1stExon", "5'UTR"),]
    }
        
    return(FullAnnot)
}

library(DT)
library(ggplot2)

server <- function(input, output) {
    
    options(shiny.maxRequestSize=100*1024^2)
    
    output$restext <- renderUI({
        HTML(paste("<b>", input$test.method, "analysis result:", "</b>")) })
    
    tableInput <- reactive({
        inFile <- eventReactive(input$go, input$cpg.pval)
        if(is.null(inFile()))
            return(NULL)
        
        temp = read.table(inFile()$datapath)
        cpg.pval1 = temp[,2]
        names(cpg.pval1) = temp[,1]
        
        inputmethod = eventReactive(input$go, input$test.method)
        
        if(input$array.type=="450K"){
            suppressMessages(library(IlluminaHumanMethylation450kanno.ilmn12.hg19))
        }else{
            suppressMessages(library(IlluminaHumanMethylationEPICanno.ilm10b4.hg19))
        }
        
        if(inputmethod() == "methylglm"){
            res <- eventReactive(input$go, {
                methylglm(cpg.pval = cpg.pval1, array.type = input$array.type,
                          group = input$group, GS.list=NULL, 
                          GS.idtype = "SYMBOL", GS.type = input$GS.list, 
                          minsize = input$minsize, maxsize = input$maxsize)
            })
        }
        
        if(inputmethod() == "RRA(ORA)"){
            res <- eventReactive(input$go,{
                methylRRA(cpg.pval = cpg.pval1, array.type = input$array.type, 
                          group = input$group, method = "ORA", 
                          GS.list=NULL, GS.idtype = "SYMBOL", GS.type = input$GS.list, 
                          minsize = input$minsize, maxsize = input$maxsize)
            }) 
        }
        
        if(inputmethod() == "RRA(GSEA)"){
            res <- eventReactive(input$go,{
                methylRRA(cpg.pval = cpg.pval1, array.type = input$array.type, 
                          group = input$group, method = "GSEA", 
                          GS.list=NULL, GS.idtype = "SYMBOL", GS.type = input$GS.list, 
                          minsize = input$minsize, maxsize = input$maxsize)
            })
        }
        
        if(inputmethod() == "gometh"){
            res <- eventReactive(input$go,{
                methylgometh(cpg.pval = cpg.pval1, sig.cut = 0.001, array.type = input$array.type, 
                             GS.list=NULL, GS.idtype = "SYMBOL", GS.type = input$GS.list, 
                             minsize = input$minsize, maxsize = input$maxsize)
            })
        }
        
        res
        
    })
    
    output$resTable <- DT::renderDataTable({
        df = tableInput()
        DT::datatable(data=df()) %>% formatSignif(c("pvalue", "padj"), digits = 8)
    })
    
    plotInput <- reactive({
        inputmethod = eventReactive(input$go, input$test.method)
        
        res = tableInput()
        
        if(inputmethod() %in% c("methylglm","RRA(GSEA)")){
            validate(
                need(input$xaxis!="Count", 'Number of significant genes is not available for methlglm')
            )
        }
        
        barplot(res(), xaxis = input$xaxis, num = input$ngs, colorby = input$colorby)
        
    })
    
    output$resPlot = renderPlot({
        print(plotInput())
    })
    
    output$download1 <- downloadHandler(filename = function(){ paste0(input$test.method,"_result.csv") }, 
                                        content = function(fname){ write.csv(tableInput()(), fname)})
    
    output$download2 <- downloadHandler(filename = function(){ paste0(input$test.method,"_result.txt") }, 
                                        content = function(fname){ write.table(tableInput()(), fname, quote = FALSE, row.names = FALSE)})
    
    output$downloadPlot1 <- downloadHandler(filename = function() { paste0(input$test.method, '_plot.pdf') },
                                            content = function(fname){ ggsave(fname, plotInput(), device = "pdf", width = 30, height = 30, units = "cm")})
    output$downloadPlot2 <- downloadHandler(filename = function() { paste0(input$test.method, '_plot.png') },
                                            content = function(fname){ ggsave(fname, plotInput(), device = "png", width = 30, height = 30, units = "cm")})
    
}

#' @title Prepare user-supplied mapping between CpGs and genes.
#'
#' @description This function prepares CpG to gene mapping which will be
#' used by methylRRA and methylglm.
#' @param CpG2Gene A matrix, or a data frame or a list contains CpG to gene
#' mapping. For a matrix or data frame, 1st column should be CpG ID and 2nd
#' column should be gene name. For a list, entry names should be gene names,
#' and elements correpond to CpG IDs.
#' @param geneidtype A string. "SYMBOL", "ENSEMBL", "ENTREZID" or "REFSEQ".
#' Default is "SYMBOL".
#' @export
#' @import org.Hs.eg.db
#' @importFrom AnnotationDbi select
#' @return A data frame contains ready to use CpG to gene mapping.
#' @references Carlson M (2017). org.Hs.eg.db:
#' Genome wide annotation for Human. R package version 3.5.0.
#' @examples
#' data(CpG2Genetoy)
#' FullAnnot = prepareAnnot(CpG2Gene)
#' head(FullAnnot)

prepareAnnot <- function(CpG2Gene, geneidtype = "SYMBOL"){
    geneidtype = match.arg(
        geneidtype,c("SYMBOL", "ENSEMBL", "ENTREZID", "REFSEQ"))

    if(is.matrix(CpG2Gene)|is.data.frame(CpG2Gene)){
        if(!is.character(CpG2Gene[,1])){
            stop("CpG ID should be characters")
        }
        if(ncol(CpG2Gene)!=2){
            stop("CpG2Gene should contain two columns")
        }
        FullAnnot = data.frame(CpG2Gene)
    }else if(is.list(CpG2Gene)){
        FullAnnot = data.frame(
            CpG = unlist(CpG2Gene),
            gene = rep(names(CpG2Gene),vapply(CpG2Gene, length, FUN.VALUE = 0)))
    }else{
        stop("CpG2Gene should be a matrix or a data frame or a list.")
    }
    
    colnames(FullAnnot) = c("Name", "UCSC_RefGene_Name")

    if(geneidtype!="SYMBOL"){
        temp = suppressMessages(
            select(org.Hs.eg.db, FullAnnot$UCSC_RefGene_Name,
                        columns = "SYMBOL",keytype = geneidtype))
        FullAnnot$UCSC_RefGene_Name = temp$SYMBOL
    }
    rownames(FullAnnot) = FullAnnot$Name
    return(FullAnnot)
}

context("Test internal functions")

library(org.Hs.eg.db)
library(reactome.db)
data(GSlisttoy)
data(CpG2Genetoy)

test_that("check prepareAnnot", {
    colnames(CpG2Gene) = c("Name", "UCSC_RefGene_Name")
    rownames(CpG2Gene) = CpG2Gene$Name
    expect_identical(prepareAnnot(CpG2Gene), CpG2Gene)
})

test_that("check getGS", {
    geneids = GS.list[[1]]
    #GOs = suppressMessages(
    #    na.omit(unique(
    #        select(org.Hs.eg.db, geneids, "GO",keytype = "SYMBOL")$GO)))
    #GOdf = suppressMessages(
    #    select(org.Hs.eg.db, GOs, "SYMBOL", keytype = "GO"))
    #genesymbol = GOdf$SYMBOL
    #names(genesymbol) = GOdf$GO
    #GO.list = split(genesymbol, names(genesymbol))

    #expect_identical(getGS(geneids, "GO"), GO.list)

    KEGGs = suppressMessages(
        na.omit(unique(
            select(org.Hs.eg.db, geneids, "PATH",keytype = "SYMBOL")$PATH)))
    KEGGdf = suppressMessages(
        select(org.Hs.eg.db, KEGGs, "SYMBOL", keytype = "PATH"))
    genesymbol = KEGGdf$SYMBOL
    names(genesymbol) = KEGGdf$PATH
    KEGG.list = split(genesymbol, names(genesymbol))

    expect_identical(getGS(geneids, "KEGG"), KEGG.list)

    gene.entrez = suppressMessages(
        select(org.Hs.eg.db, geneids,
               columns = "ENTREZID",keytype = "SYMBOL")$ENTREZID)
    reactome.df = suppressMessages(
        select(reactome.db, gene.entrez,
               columns = "REACTOMEID", keytype = "ENTREZID"))
    reactom2symbol = suppressMessages(
        select(org.Hs.eg.db, reactome.df$ENTREZID,
               columns = "SYMBOL", keytype = "ENTREZID")$SYMBOL)
    names(reactom2symbol) = reactome.df$REACTOMEID
    reactome.list = split(reactom2symbol, names(reactom2symbol))

    expect_identical(getGS(geneids, "Reactome"), reactome.list)

})

#' @title An example of user input gene sets
#'
#' @description An example of user input gene sets
#' @docType data
#' @name GS.list
#' @usage GS.list
#' @format A list contains user input gene set
#' names and their corresponding genes
#' @keywords datasets
NULL

#' @title An example of user input cpg.pval
#'
#' @description An example of user input cpg.pval
#' @docType data
#' @name cpg.pval
#' @usage cpg.pval
#' @format A named vector contains p-values of each probe tested
#' @keywords datasets
NULL


#' @title An example of user user-supplied mapping between CpGs and genes
#'
#' @description An example of user user-supplied mapping between CpGs and genes
#' @docType data
#' @name CpG2Gene
#' @usage CpG2Gene
#' @format A data frame contains mapping between CpGs and genes
#' @keywords datasets
NULL

#' @title Get Gene Sets
#'
#' @description This function gets gene sets information.
#' @param geneids A vector contains all gene ids of interest. Gene ids should
#' be gene symbol.
#' @param GS.type A string. "GO", "KEGG", or "Reactome".
#' @export
#' @import org.Hs.eg.db
#' @import reactome.db
#' @importFrom AnnotationDbi select
#' @return A list contains all gene sets of
#' interest and their corresponding genes.
#' @references Carlson M (2017). org.Hs.eg.db:
#' Genome wide annotation for Human. R package version 3.5.0.
#' @references Ligtenberg W (2017). reactome.db:
#' A set of annotation maps for reactome. R package version 1.62.0.
#' @examples
#' geneids = c("FKBP5", "NDUFA1", "STAT5B")
#' GO.list = getGS(geneids, "KEGG")
#' head(GO.list)

getGS = function(geneids, GS.type){
    message("retrieving ", GS.type, " sets...")
    if(GS.type == "KEGG"){
        GS.type = "PATH"
    }
    if(GS.type == "GO"){
        GS.type = "GOALL"
    }
    if(GS.type == "Reactome"){
        ## first convert id to entrezid to use reactome.db
        gene.entrez = suppressMessages(
            select(org.Hs.eg.db, geneids,
                        columns = "ENTREZID",keytype = "SYMBOL")$ENTREZID)
        GOdf = suppressMessages(
            select(reactome.db, gene.entrez,
                        columns = "REACTOMEID", keytype = "ENTREZID"))
        genesymbol = suppressMessages(
            select(org.Hs.eg.db, GOdf$ENTREZID,
                        columns = "SYMBOL", keytype = "ENTREZID")$SYMBOL)
        GS.type = "REACTOMEID"

    }else{
        GOs = suppressMessages(
            na.omit(unique(
                select(org.Hs.eg.db, geneids,
                            GS.type,keytype = "SYMBOL")[,GS.type])))
        GOdf = suppressMessages(
            select(org.Hs.eg.db, GOs, "SYMBOL", keytype = GS.type))
        genesymbol = GOdf$SYMBOL
    }
    names(genesymbol) = GOdf[,GS.type]
    GO.list = split(genesymbol, names(genesymbol))
    return(GO.list)
}

#' @title Enrichment analysis after adjusting multiple p-values of
#' each gene by Robust Rank Aggregation
#'
#' @description This function implements enrichment after adjusting
#' multiple p-values of each gene by Robust Rank Aggregation.
#' @param cpg.pval A named vector containing p-values of differential
#' methylation test. Names should be CpG IDs.
#' @param array.type A string. Either "450K" or "EPIC". Default is "450K".
#' This argument will be ignored if FullAnnot is provided.
#' @param FullAnnot A data frame provided by prepareAnnot function.
#' Default is NULL.
#' @param group A string. "all", "body", "promoter1" or "promoter2". 
#' Default is "all". If group = "body", only CpGs on gene body will be 
#' considered in methylRRA. If group = "promoter1" or group = "promoter2", 
#' only CpGs on promoters will be considered. Here is the definition of "body", 
#' "promoter1" and "promoter2" according to the annotation in 
#' IlluminaHumanMethylation450kanno.ilmn12.hg19 or 
#' IlluminaHumanMethylationEPICanno.ilm10b4.hg19. 
#' \itemize{
#'   \item body: CpGs whose gene group correspond to "Body" or "1stExon" 
#'   \item promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
#'   \item promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
#'   "1stExon", or "5'UTR". 
#' }
#' If group = "all", all CpGs are considered regardless of their gene group.
#' @param method A string. "ORA" or "GSEA". Default is "ORA"
#' @param sig.cut A numeric value indicating FDR cut-off for significant gene
#' in ORA. Default is 0.05. This argument will be ignored if topDE is provided
#' or method = "GSEA" is used.
#' @param topDE An integer. The top number of genes to be declared as 
#' significant after robust rank aggregation. This argument will be ignored
#' if method = "GSEA" is used.
#' @param GS.list A list. Default is NULL. If there is no input list,
#' Gene Ontology is used. Entry names are gene sets names, and elements
#' correpond to genes that gene sets contain.
#' @param GS.idtype A string. "SYMBOL", "ENSEMBL", "ENTREZID" or
#' "REFSEQ". Default is "SYMBOL".
#' @param GS.type A string. "GO", "KEGG", or "Reactome". Default is "GO"
#' @param minsize An integer. If the number of genes in a gene set is
#' less than this integer, this gene set is not tested. Default is 100.
#' @param maxsize An integer. If the number of genes in a gene set is
#' greater than this integer, this gene set is not tested. Default is 500.
#' @export
#' @import stats
#' @import RobustRankAggreg
#' @importFrom clusterProfiler GSEA
#' @import org.Hs.eg.db
#' @importFrom AnnotationDbi select
#' @return A data frame contains gene set tests results.
#' @references Kolde, Raivo, et al. Robust rank aggregation for gene
#' list integration and meta-analysis. Bioinformatics 28.4 (2012): 573-580.
#' @references Phipson, B., Maksimovic, J., and Oshlack, A. (2015).
#' missMethyl: an R package for analysing methylation data from Illuminas
#' HumanMethylation450 platform. Bioinformatics, btv560.
#' @references Yu, Guangchuang, et al. clusterProfiler: an R package for
#' comparing biological themes among gene clusters. Omics: a journal of
#' integrative biology 16.5 (2012): 284-287.
#' @references Carlson M (2017). org.Hs.eg.db: Genome wide annotation for
#' Human. R package version 3.5.0.
#' @examples
#' data(CpG2Genetoy)
#' data(cpgtoy)
#' data(GSlisttoy)
#' GS.list = GS.list[1:10]
#' FullAnnot = prepareAnnot(CpG2Gene)
#' res1 = methylRRA(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
#' method = "ORA", GS.list = GS.list)
#' head(res1)

methylRRA <- function(cpg.pval, array.type = "450K", FullAnnot = NULL, 
                            group = "all", method = "ORA", sig.cut = 0.05, 
                            topDE = NULL, GS.list=NULL, 
                            GS.idtype = "SYMBOL", GS.type = "GO", 
                            minsize = 100, maxsize = 500){
    ##  check input
    if(!is.vector(cpg.pval)|!is.numeric(cpg.pval)|is.null(names(cpg.pval))){
        stop("Input CpG pvalues should be a named vector")
    }
    if(sum(cpg.pval==0)>0){
        stop("Input CpG pvalues should not contain 0")
    }
    if(!is.list(GS.list)&!is.null(GS.list)){
        stop("Input gene sets should be a list")
    }
        
    stopifnot(length(sig.cut)==1)
    if(!is.numeric(sig.cut) | sig.cut>=1 | sig.cut<=0){
        stop("sig.cut should be a number between 0 and 1")
    }
    if(!is.null(topDE)){
        stopifnot(length(topDE)==1)
        if(!is.numeric(topDE)|floor(topDE)<=0){
            stop("topDE should be a positive integer")
        }
    }
    
    stopifnot(length(minsize)==1)
    if(!is.numeric(minsize) | minsize<0){
        stop("minsize should be a positive number")
    }
    stopifnot(length(maxsize)==1)
    if(!is.numeric(maxsize) | maxsize<0){
        stop("maxsize should be a positive number")
    }
    if(maxsize<minsize){
        stop("maxsize should be greater than minsize")
    }
    
    ## match argument and make gene id to be gene symbol
    method = match.arg(method, c("ORA", "GSEA"))
    GS.idtype = match.arg(GS.idtype,
                                c("SYMBOL", "ENSEMBL", "ENTREZID", "REFSEQ"))
    if(!is.null(GS.list) & GS.idtype!="SYMBOL"){
        GS.list = suppressMessages(lapply(GS.list, function(x)
            select(org.Hs.eg.db, x, columns = "SYMBOL",
                   keytype = GS.idtype)$SYMBOL))
    }
    GS.type = match.arg(GS.type, c("GO", "KEGG", "Reactome"))
    group = match.arg(group, c("all", "body", "promoter1", "promoter2"))

    ##  get annotation
    if(is.null(FullAnnot)){
        stopifnot(length(array.type)==1)
        if(array.type!="450K" & array.type!="EPIC"){
            stop("Input array type should be either 450K or EPIC")
        }
        if(array.type=="450K"){
            FullAnnot = getAnnot("450K", group)
        }else{
            FullAnnot = getAnnot("EPIC", group)
        }
            
    }

    cpg.intersect = intersect(names(cpg.pval), rownames(FullAnnot))
    cpg.pval = cpg.pval[cpg.intersect]
    ## match user input CpG to our FullAnnot database
    FullAnnot.sub = FullAnnot[names(cpg.pval), ]
    ## change CpG ids to gene symbols
    names(cpg.pval) = FullAnnot.sub$UCSC_RefGene_Name
    ## convert cpg.pval to a list, each element of this
    # list is a gene and it's corresponding cpg pvalue
    geneID.list = split(cpg.pval, names(cpg.pval))
    ## for each gene, compute its rho score
    rho = vapply(geneID.list, rhoScores, FUN.VALUE = 1)
    ## for each gene, compute its beta value
    #minbeta = vapply(geneID.list, function(x)
    #    min(betaScores(x)), FUN.VALUE = 1)
    
    flag = 0
    if(is.null(GS.list)){
        GS.list = getGS(names(geneID.list), GS.type = GS.type)
        flag = 1
    }
    GS.list = lapply(GS.list, na.omit)

    ## calculate gene set size
    GS.sizes = vapply(GS.list, length, FUN.VALUE = 0)
    ## filter gene sets by their sizes
    GS.list.sub = GS.list[GS.sizes>=minsize & GS.sizes<=maxsize]
    message(length(GS.list.sub), " gene sets are being tested...")
    size = vapply(GS.list.sub, length, FUN.VALUE = 0)
    ID = names(GS.list.sub)
    gs.pval = rep(NA, length(GS.list.sub))
    Count = rep(NA, length(GS.list.sub))

    if(method=="ORA"){
        if(is.null(topDE)){ 
            ## if topDE is not provided, declare significant genes by sig.cut
            rhoadj = p.adjust(rho, method = "BH")
            DEgenes = names(rhoadj)[rhoadj<sig.cut]
            if(length(DEgenes)==0){
                warning("No gene is significant under cut-off ", sig.cut, 
                        ". Use a higher cut-off or \"topDE\" argument.")
            }else{
                message(length(DEgenes), 
                        " genes are significant under cut-off ", sig.cut)
            } 
        }else{
            ## if topDE is provided, use topDE
            rho = rho[order(rho)]
            DEgenes = names(rho)[seq_len(floor(topDE))]
        }
        
        ##  total number of genes
        N = length(unique(FullAnnot.sub$UCSC_RefGene_Name))
        ##  number of DE genes
        m = length(DEgenes)
        if(m==0){
            gs.pval = 1
            Count = 0 
        }else{
            overlap.genes = lapply(GS.list.sub, 
                function(x) DEgenes[DEgenes%in%x])
            Q = vapply(overlap.genes, length, 0)
            Count = Q
            gs.pval = phyper(q = Q, m = m, n = N-m, k = size, lower.tail=FALSE)
            overlap.genes.vec = 
                vapply(overlap.genes, function(x) paste(x, collapse = ","), "")
        }
        gs.padj = p.adjust(gs.pval, method = "BH")
        
        if(flag==1){
            des = getDescription(GSids = ID, GS.type = GS.type)
            if(all(Count==0)){
                res = data.frame(ID = ID, Description = des, Count = Count, 
                    Size = size, pvalue = gs.pval, padj = gs.padj)
            }else{
                res = data.frame(ID = ID, Description = des, Count = Count, 
                    overlap = overlap.genes.vec, Size = size,
                    pvalue = gs.pval, padj = gs.padj)
            }
            
        }else{
            if(all(Count==0)){
                res = data.frame(ID = ID, Count = Count, Size = size,
                    pvalue = gs.pval, padj = gs.padj)
            }else{
                res = data.frame(ID = ID, Count = Count, 
                    overlap = overlap.genes.vec, Size = size, 
                    pvalue = gs.pval, padj = gs.padj)
            }
        }
        rownames(res) = ID
        res = res[order(res$pvalue), ]
        message("Done!")
        return(res)
    }

    if(method == "GSEA"){
        zscore = qnorm(rho/2, lower.tail = FALSE)
        zscore = zscore[order(zscore, decreasing = TRUE)]
        zscore[is.infinite(zscore)] = suppressWarnings(
            max(zscore[-which(is.infinite(zscore))]))
        
        ## drop the gene sets that has all zero z-scores
        allzero = vapply(GS.list, function(x){
            x = intersect(x, names(zscore))
            ifelse(all(na.omit(zscore[x])==0), TRUE, FALSE)
            }, FALSE) 
        GS.list = GS.list[!allzero]
        
        GS2gene = data.frame(
            ont = rep(names(GS.list), vapply(GS.list, length, FUN.VALUE = 0)),
                gene = unlist(GS.list))
        
        GSEAres = GSEA(geneList = zscore, minGSSize = minsize,
                            maxGSSize = maxsize, pvalueCutoff = 1,
                            TERM2GENE = GS2gene)
        GSEAres = GSEAres[,c("ID","setSize","enrichmentScore", "NES","pvalue",
            "p.adjust", "leading_edge","core_enrichment")]
        GSEAres = data.frame(GSEAres)
        if(flag==1){
            des = getDescription(GSids = GSEAres$ID, GS.type = GS.type)
            GSEAres$Description = des 
            GSEAres = GSEAres[,c("ID","Description","setSize","enrichmentScore",
                "NES","pvalue","p.adjust","leading_edge","core_enrichment")]
        }
        colnames(GSEAres)[which(colnames(GSEAres)=="setSize")] = "Size"
        colnames(GSEAres)[which(colnames(GSEAres)=="p.adjust")] = "padj"
        message("Done!")
        return(GSEAres)
    }
}

#' @title Adjusting number of probes in gene set testing
#' using gometh or gsameth in missMethyl
#'
#' @description This function calls gometh or gsameth function
#' in missMethyl package to adjust number of probes in gene set testing
#' @param cpg.pval A named vector containing p-values of
#' differential methylation test. Names should be CpG IDs.
#' @param sig.cut A numeric value indicating cut-off value for significant CpG.
#' Default is 0.001. This argument will be ignored if topDE is provided. 
#' @param topDE An integer. The top number of CpGs to be declared as 
#' significant.
#' @param array.type A string. Either "450K" or "EPIC". Default is "450K".
#' @param GS.list A list. Default is NULL. If there is no input list,
#' Gene Ontology is used. Entry names are gene sets names, and elements
#' correpond to genes that gene sets contain.
#' @param GS.idtype A string. "SYMBOL", "ENSEMBL", "ENTREZID" or "REFSEQ".
#' Default is "SYMBOL".
#' @param GS.type A string. "GO", "KEGG", or "Reactome"
#' @param minsize An integer. If the number of genes in a gene set
#' is less than this integer, this gene set is not tested. Default is 100.
#' @param maxsize An integer. If the number of genes in a gene set
#' is greater than this integer, this gene set is not tested. Default is 500.
#' @export
#' @import stats
#' @importFrom missMethyl gometh
#' @importFrom missMethyl gsameth
#' @import reactome.db
#' @importFrom AnnotationDbi select
#' @import org.Hs.eg.db
#' @importFrom stringr str_length
#' @return A data frame contains gene set tests results.
#' @references Phipson, B., Maksimovic, J., and Oshlack, A. (2015).
#' missMethyl: an R package for analysing methylation data from Illuminas
#' HumanMethylation450 platform. Bioinformatics, btv560.
#' @references Ligtenberg W (2017). reactome.db: A set of annotation maps
#' for reactome. R package version 1.62.0.
#' @references Carlson M (2017). org.Hs.eg.db: Genome wide annotation
#' for Human. R package version 3.5.0.
#' @examples
#' \dontrun{
#' library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
#' data(cpgtoy)
#' res = methylgometh(cpg.pval = cpg.pval, sig.cut = 0.001, GS.type = "KEGG",
#' minsize = 200, maxsize = 205)
#' head(res)
#' }


methylgometh <- function(cpg.pval, sig.cut = 0.001, topDE = NULL,
                                array.type = "450K",
                                GS.list=NULL, GS.idtype = "SYMBOL",
                                GS.type = "GO",
                                minsize = 100, maxsize = 500){
    ## check input
    if(!is.vector(cpg.pval)|!is.numeric(cpg.pval)|is.null(names(cpg.pval))){
        stop("Input CpG pvalues should be a named vector")
    }
    if(sum(cpg.pval==0)>0){
        stop("Input CpG pvalues should not contain 0")
    }
    if(!is.list(GS.list)&!is.null(GS.list)){
        stop("Input gene sets should be a list")
    }
        
    stopifnot(length(sig.cut)==1)
    if(!is.numeric(sig.cut) | sig.cut>=1 | sig.cut<=0){
        stop("sig.cut should be a number between 0 and 1")
    }
    if(!is.null(topDE)){
        if(!is.numeric(topDE)|floor(topDE)<=0){
            stop("topDE should be a positive integer")
        }
    }
    
    stopifnot(length(array.type)==1)
    if(array.type!="450K" & array.type!="EPIC"){
        stop("Input array type should be either 450K or EPIC")
    }
        
    GS.type = match.arg(GS.type, c("GO", "KEGG", "Reactome"))
    
    stopifnot(length(minsize)==1)
    if(!is.numeric(minsize) | minsize<0){
        stop("minsize should be a positive number")
    }
    stopifnot(length(maxsize)==1)
    if(!is.numeric(maxsize) | maxsize<0){
        stop("maxsize should be a positive number")
    }
    if(maxsize<minsize){
        stop("maxsize should be greater than minsize")
    }

    if(is.null(topDE)){
        ## if topDE is not provided, declare significant genes by sig.cut
        sig.cpg = names(cpg.pval)[cpg.pval < sig.cut]
        if(length(sig.cpg)==0){
            warning("No CpG is significant under cut-off ", sig.cut, 
                    ". Use a higher cut-off or \"topDE\" argument.")
        }else{
            message(length(sig.cpg), 
                    " CpGs are significant under cut-off ", sig.cut)
        }
    }else{
        stopifnot(length(topDE)==1)
        if(!is.numeric(topDE)|floor(topDE)<=0){
            stop("topDE should be a positive integer")
        }
        cpg.pval = cpg.pval[order(cpg.pval)]
        sig.cpg = names(cpg.pval)[seq_len(floor(topDE))]
    }
    
    if(is.null(GS.list) & (GS.type=="GO"|GS.type=="KEGG")){
        message(GS.type, " are being tested...")
        res = gometh(sig.cpg = sig.cpg, all.cpg = names(cpg.pval),
            collection = GS.type, array.type=array.type,
            plot.bias = FALSE, prior.prob = TRUE)
        res = res[res$N>=minsize & res$N<=maxsize,]
        res = res[order(res$P.DE),]
        res$ID = rownames(res)
        if(GS.type=="GO"){
            colnames(res) = c("Description", "Ont", "Size", "Count", 
                "pvalue", "padj", "ID")
        }else{
            colnames(res) = c("Description", "Size", "Count", 
                "pvalue", "padj", "ID")
        }
        ## re-calculate adjusted p-value
        res$padj = p.adjust(res$pvalue,method = "BH")
        message("Done!")
        return(res)
    }

    if(is.null(GS.list) & GS.type=="Reactome"){
        message(GS.type, " are being tested...")
        if(array.type=="450K"){
            tempAnnot = getAnnot("450K")
        }else{
            tempAnnot = getAnnot("EPIC")
        }
            
        temp = unique(tempAnnot$UCSC_RefGene_Name)

        gene.entrez = suppressMessages(
            select(org.Hs.eg.db, temp, columns = "ENTREZID",
                        keytype = "SYMBOL")$ENTREZID)
        reactome.df = suppressMessages(
            select(reactome.db, gene.entrez, columns = "REACTOMEID",
                keytype = "ENTREZID"))
        reactome.df = na.omit(reactome.df)
        reactom2entrez = reactome.df$ENTREZID
        names(reactom2entrez) = reactome.df$REACTOMEID
        reactome.list = split(reactom2entrez, names(reactom2entrez))
        reactome.list.sizes = vapply(reactome.list, length, FUN.VALUE = 1)
        reactome.list.sub =
            reactome.list[
                reactome.list.sizes>=minsize & reactome.list.sizes<=maxsize]

        res = gsameth(sig.cpg = sig.cpg, all.cpg = names(cpg.pval),
                            collection = reactome.list.sub,
                            array.type=array.type,
                            plot.bias = FALSE, prior.prob = TRUE)
        res = data.frame(res)
        res = res[res$N>=minsize & res$N<=maxsize,]
        ID = rownames(res)
        Description = getDescription(rownames(res), "Reactome")
        res = cbind(ID, Description, res)
        res = res[order(res[,"P.DE"]),]
        colnames(res) = c("ID", "Description", "Size", 
            "Count", "pvalue", "padj")
        ## re-calculate adjusted p-value
        res$padj = p.adjust(res$pvalue,method = "BH")
        message("Done!")
        return(res)
    }else{
        if(!is.null(GS.list) & GS.idtype!="ENTREZID"){
            message("Converting gene IDs...")
        GS.list.entrezid = suppressMessages( lapply(GS.list, function(x)
            select(org.Hs.eg.db, x, columns = "ENTREZID",
                        keytype = GS.idtype)$ENTREZID))
        }else{
            GS.list.entrezid = GS.list
        }
            
        GS.list.entrezid = lapply(GS.list.entrezid, na.omit)
        GS.sizes = vapply(GS.list.entrezid, length, FUN.VALUE = 1)
        GS.list.sub = GS.list.entrezid[GS.sizes>=minsize & GS.sizes<=maxsize]
        ## filter gene sets by their sizes
        message(length(GS.list.sub), " gene sets are being tested...")
        res = gsameth(sig.cpg = sig.cpg, all.cpg = names(cpg.pval),
                            collection = GS.list.sub, array.type=array.type,
                            plot.bias = FALSE, prior.prob = TRUE)
        res = data.frame(res)
        ID = rownames(res)
        res = cbind(ID, res)
        res = res[order(res[,"P.DE"]),]
        colnames(res) = c("ID", "Size", "Count", "pvalue", "padj")
        message("Done!")
        return(res)
    }
}

#' @title Barplot for methylGSA analysis result
#'
#' @description This function visualizes methylGSA analysis result by barplot.
#' 
#' @param res A data frame which contains methylGSA analysis result. 
#' @param xaxis A string which specify the x-axis in the barplot. 
#' Either "Size" (number of genes in gene set) or "Count" 
#' (number of significant genes in gene set). Default is "Size". "Count" option
#' is not available for methylglm and methylRRA(GSEA) result.
#' @param num An integer. Number of gene sets to display on the barplot. 
#' Default is 5.
#' @param colorby A string. Either "pvalue" or "padj". Default is "padj".
#' @param title A string. Barplot title. Default is NULL.
#' @import ggplot2
#' 
#' @details The implementation of the function is adapted from barplot function
#' in enrichplot package.
#' @export
#' @return ggplot object
#' @references Yu G (2018). enrichplot: Visualization of Functional Enrichment 
#' Result. R package version 1.0.2, https://github.com/GuangchuangYu/enrichplot.
#' @examples
#' res = data.frame(ID = c("04144", "04510", "04740", "04810", "05200"),
#'                  Description = c("Endocytosis", "Focal adhesion", 
#'                  "Olfactory transduction", 
#'                  "Regulation of actin cytoskeleton", "Pathways in cancer"),
#'                  Size = c(201, 200, 388, 213, 326),
#'                  pvalue = c(0.481, 0.696, 1, 1, 1),
#'                  padj = 1
#'                  )
#' barplot(res)

barplot <- function(res, xaxis = "Size", num = 5, 
                    colorby = "padj", title = ""){
    
    # if Description is not provided, use ID as text
    txt = ifelse("Description"%in%colnames(res), "Description", "ID")
    
    xaxis = match.arg(xaxis, c("Size", "Count"))
    colorby = match.arg(colorby, c("pvalue", "padj"))
    
    if(!is.numeric(num)){
        stop("num should be an integer.")
    }
        
    if(!"Count"%in%colnames(res)&xaxis=="Count"){
        warning("\"Count\" option not available. \"Size\" is used.")
        xaxis = "Size"
    }
    
    if("Description"%in%colnames(res)){
        res = res[!is.na(res$Description),]
        res$Description = factor(res$Description, 
            levels=rev(unique(res$Description)))
    }else{
        res = res[!is.na(res$ID),]
        res$ID = factor(res$ID, levels=rev(unique(res$ID)))
    }
    
    if(nrow(res)>num){
        res = res[seq_len(num),]
    }
        
    ggplot(res, aes_string(x = txt, y = xaxis, fill = colorby)) +
        scale_fill_continuous(low="red", high="blue", name = colorby, 
            guide=guide_colorbar(reverse=TRUE))+
        geom_bar(stat = "identity") + coord_flip() +
        ggtitle(title) + xlab(NULL) + ylab(xaxis)
}

library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
library(minfi)
library(stringr)
FullAnnot = getAnnotation(IlluminaHumanMethylation450kanno.ilmn12.hg19)
FullAnnot = FullAnnot[,c("Name","UCSC_RefGene_Name")]
FullAnnot = FullAnnot[str_length(rownames(FullAnnot))==10,]
FullAnnot = FullAnnot[!FullAnnot$UCSC_RefGene_Name=="",]
temp = vapply(strsplit(FullAnnot$UCSC_RefGene_Name,split=";"),
              '[', 1, FUN.VALUE=character(1))
FullAnnot$UCSC_RefGene_Name = temp
colnames(FullAnnot) = c("CpG", "Gene")
rownames(FullAnnot) = NULL
CpG2Gene = FullAnnot
CpG2Gene = data.frame(CpG2Gene)

save(CpG2Gene, file = 'data/CpG2Genetoy.RData', compress = 'xz')

#' @title methylGSA shiny app
#' 
#' @description This is an interface for Bioconductor package methylGSA.
#' @note In order to run the app, the following R/Bioconductor packages needs
#' to be installed properly: shinycssloaders, DT, ggplot2, 
#' IlluminaHumanMethylation450kanno.ilmn12.hg19 (if analyzing 450K array)
#' IlluminaHumanMethylationEPICanno.ilm10b4.hg19 (if analyzing EPIC array)
#' @param run Run the app or not. Default is TRUE
#' @importFrom shiny runApp
#' @return The shiny app will be opened in a web browser.
#' @export
#' @examples 
#' ## Please note: in this example, the argument run is set to be FALSE in 
#' ## order to pass R CMD check. However, when using the app, users are 
#' ## expected to launch the app by runExample()
#' runExample(FALSE)
runExample = function(run=TRUE) {
    if(run){
        appDir = system.file("shiny", "myapp", package = "methylGSA")
        if (appDir == "") {
            stop("Could not find example directory. 
                 Try re-installing `methylGSA`.", call. = FALSE)
        }
        runApp(appDir, display.mode = "normal")
        
    }
}

library(minfi)
library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
library(stringr)

FullAnnot = getAnnotation(IlluminaHumanMethylation450kanno.ilmn12.hg19)
FullAnnot = FullAnnot[,c("Name","UCSC_RefGene_Name")]
FullAnnot = FullAnnot[str_length(rownames(FullAnnot))==10,]
FullAnnot = FullAnnot[!FullAnnot$UCSC_RefGene_Name=="",]
temp = vapply(strsplit(FullAnnot$UCSC_RefGene_Name,split=";"),
              '[', 1, FUN.VALUE=character(1))
FullAnnot$UCSC_RefGene_Name = temp
gene2cpg = split(FullAnnot$Name, FullAnnot$UCSC_RefGene_Name)
probes = unlist(lapply(gene2cpg, length))
probes_order = probes[order(probes)]

set.seed(123)
GS.sizes = sample(100:300, 200)  ## sample gene sizes
GS.sizes = GS.sizes[cumsum(GS.sizes)<length(probes_order)]
GS.sizes[length(GS.sizes)] =
    length(probes_order) - sum(GS.sizes[1:(length(GS.sizes)-1)])
GS.sizescum = cumsum(GS.sizes)
GS.list = vector("list", length(GS.sizes))
GS.list[[1]] = names(probes_order)[1:GS.sizes[1]]
names(GS.list)[1] = "GS1"
for(i in 2:length(GS.sizes)){
    GS.list[[i]] = names(probes_order)[ (GS.sizescum[i-1]+1):GS.sizescum[i] ]
    names(GS.list)[i] = paste0("GS", i)
}
save(GS.list, file = 'data/GSlisttoy.RData', compress = 'xz')

#' @title Get gene set description
#'
#' @description This function gets description of gene sets.
#' @param GSids A vector contains gene set IDs.
#' @param GS.type A string. "GO", "KEGG", or "Reactome".
#' @export
#' @import GO.db
#' @importFrom clusterProfiler download_KEGG
#' @import reactome.db
#' @import AnnotationDbi
#' 
#' @return A vector contains gene sets description.
#' @references Carlson M (2018). GO.db: A set of annotation maps describing 
#' the entire Gene Ontology. R package version 3.6.0.
#' @references Yu G, Wang L, Han Y, He Q (2012). clusterProfiler: an R package 
#' for comparing biological themes among gene clusters. OMICS: A Journal 
#' of Integrative Biology, 16(5), 284-287.
#' @references Ligtenberg W (2017). reactome.db:
#' A set of annotation maps for reactome. R package version 1.62.0.
#' @examples
#' GSids = c("GO:0007389", "GO:0000978", "GO:0043062")
#' Description = getDescription(GSids, "GO")
#' head(Description)

getDescription <- function(GSids, GS.type){
    if(GS.type=="GO"){
        goterms = unlist(Term(GOTERM))
        temp = as.character(goterms[GSids])
        return(temp)
    }
    if(GS.type=="KEGG"){
        KEGGID2NAME = 
            download_KEGG("hsa", keggType="KEGG", 
                keyType="kegg")$KEGGPATHID2NAME
        rownames(KEGGID2NAME) = KEGGID2NAME$from
        temp = as.character(KEGGID2NAME[paste0("hsa",GSids), "to"])
        return(temp)
    }
    if(GS.type=="Reactome"){
        Reactome2NAME = unlist(as.list(reactomePATHID2NAME))
        temp = as.character(Reactome2NAME[GSids])
        return(temp)
    }
    
}

library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
library(minfi)
library(stringr)
FullAnnot = getAnnotation(IlluminaHumanMethylation450kanno.ilmn12.hg19)
FullAnnot = FullAnnot[,c("Name","UCSC_RefGene_Name")]
FullAnnot = FullAnnot[str_length(rownames(FullAnnot))==10,]
FullAnnot = FullAnnot[!FullAnnot$UCSC_RefGene_Name=="",]

set.seed(123)
cpg.pval = runif(dim(FullAnnot)[1])
names(cpg.pval) = FullAnnot$Name
cpg.pval = round(cpg.pval, 4)
##  make sure pvalue is not 0
cpg.pval[cpg.pval==0] = 0.001
##  make some cpg to be significant
ind = sample(dim(FullAnnot)[1], 1000)
cpg.pval[ind] = 0.001
save(cpg.pval, file = 'data/cpgtoy.RData', compress = 'xz')

## About

### Authors


[Xu Ren](https://github.com/reese3928) (xu.ren@stonybrook.edu)        
[Pei Fen Kuan](http://www.ams.stonybrook.edu/~pfkuan/) (peifen.kuan@stonybrook.edu)   

This Shiny app is an interface for Bioconductor package methylGSA. 

The Bioconductor package can be found [here](https://bioconductor.org/packages/release/bioc/html/methylGSA.html).    
The Bioconductor package vignette can be found [here](https://bioconductor.org/packages/release/bioc/vignettes/methylGSA/inst/doc/methylGSA-vignette.html).      
The `methylGSA` paper can be found [here](https://doi.org/10.1093/bioinformatics/bty892).


### Citation

Ren, X., & Kuan, P. F. (2019). methylGSA: a Bioconductor package and Shiny app for DNA methylation data length bias adjustment in gene set testing. Bioinformatics, 35(11), 1958-1959.

@article{ren2019methylgsa,    
title={methylGSA: a Bioconductor package and Shiny app for DNA methylation data length bias adjustment in gene set testing},    
author={Ren, Xu and Kuan, Pei Fen},    
journal={Bioinformatics},    
volume={35},    
number={11},    
pages={1958--1959},    
year={2019},    
publisher={Oxford University Press}    
}

## Step by step instructions for methylGSA shiny app    
#### Xu Ren and Pei Fen Kuan  
#### 2020-02-20

This app is a web interface for gene set testing using the outcome of differential methylation. 

### Step 1
Click on "Browse" to upload differential methylation result. 

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step1.png" style="width:40.0%">


Users are expected to upload a txt file with 1st column CpG IDs, and 2nd column p-values correspond to the CpGs. For example:

<hr />

cg13869341 &nbsp;&nbsp; 0.307766 <br>
cg14008030 &nbsp;&nbsp; 0.257672 <br>
cg12045430 &nbsp;&nbsp; 0.552322 <br>
cg20826792 &nbsp;&nbsp; 0.056383 <br>
cg00381604 &nbsp;&nbsp; 0.468549 <br>
cg20253340 &nbsp;&nbsp; 0.483770 <br>
cg21870274 &nbsp;&nbsp; 0.812402 <br>
... <br>
... <br>
... <br>
cg21106100 &nbsp;&nbsp; 0.079276 <br>
cg08265308 &nbsp;&nbsp; 0.748265 <br>
cg14273923 &nbsp;&nbsp; 0.553923 <br>

<hr />

Files should be no more than 100MB. Please check [**cpg_file_example.txt**](https://github.com/reese3928/methylGO-RShiny-app/raw/master/cpy_file_example.txt) for a toy dataset on Illumina 450 K Beadchip. 




### Step 2
Choose array type and group.

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step2_1.png" style="width:40.0%">
<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step2_2.png" style="width:40.0%">


Array type:  
`450K`: Illumina 450 K Beadchip   
`EPIC`: Illumina EPIC Beadchip    

Group:  
Group is the type of CpG to be considered in methylRRA or methylglm. By default, group is `all`, which means all CpGs are considered regardless of their gene group. If group is `body`, only CpGs on gene body will be considered. If group is `promoter1` or `promoter2`, only CpGs on promoters will be considered. Based on the annotation in IlluminaHumanMethylation450kanno.ilmn12.hg19 and IlluminaHumanMethylationEPICanno.ilm10b4.hg19, `body`, `promoter1` and `promoter2` are defined as:    
`body`: CpGs whose gene group correspond to “Body” or “1stExon”    
`promoter1`: CpGs whose gene group correspond to “TSS1500” or “TSS200”    
`promoter2`: CpGs whose gene group correspond to “TSS1500”, “TSS200”, “1stExon”, or “5’UTR”


### Step 3
Select gene sets to test.

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step3.png" style="width:40.0%">


`Gene Ontology`: http://www.geneontology.org  
`KEGG` (Kyoto Encyclopedia of Genes and Genomes): https://www.genome.jp/kegg/  
`Reactome`: https://reactome.org


### Step 4
Select gene set sizes.

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step4.png" style="width:40.0%">

Gene sets outsize this range will not be tested. 


### Step 5
Select gene set testing method.

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step5.png" style="width:40.0%">

Check [this page](https://bioconductor.org/packages/devel/bioc/vignettes/methylGSA/inst/doc/methylGSA-vignette.html) for a description of methods. 


### Step 6
Hit "GO!".

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/step6.png" style="width:40.0%">

Gene set testing is running in the background. Depending on the number of gene sets tested, it may take several seconds to several minutes. Once it is done, the result is going to show up on the right hand panel. 

<br>

### Interpreting the results

The result of gene set testing is presented in two formats, namely table and box plot.

Hit "Download as csv" or "Download as txt" to save the results table to a csv or txt file:

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/restable.png" style="width:70.0%">

<br>

Various options are provided for users to customize the box plot:

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/resplot1.png" style="width:70.0%">

`Number of gene sets to display`: The number of genes sets to display on the plot.  
`x-axis`: Either the number of significant genes in each gene set or the total number of genes. The number of significant genes is not available for methylglm and methylRRA(GSEA) because they are FCS methods.   
`Color by`: Color the barplot by either raw p-value or adjusted p-value. 


Hit "Download as pdf" or "Download as png" to save the boxplot to a pdf or png file:

<img src="https://github.com/reese3928/methylGO-RShiny-app/raw/master/resplot2.png" style="width:70.0%">

---
title: "methylGSA: Gene Set Analysis for DNA Methylation Datasets"
author: "Xu Ren and Pei Fen Kuan"
date: "`r Sys.Date()`"
output: 
    rmarkdown::html_document:
        highlight: pygments
        toc: true
vignette: >
    %\VignetteIndexEntry{methylGSA: Gene Set Analysis for DNA Methylation Datasets}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---


```{r, echo = FALSE}
knitr::opts_chunk$set(comment = "", message=FALSE, warning = FALSE)
```

## Installation

To install and load methylGSA

```{r eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("methylGSA")
```

```{r}
library(methylGSA)
```

Depending on the DNA methylation array type, other packages may be needed 
before running the analysis.    

If analyzing 450K array, `IlluminaHumanMethylation450kanno.ilmn12.hg19` needs 
to be loaded.
```{r}
library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
```

If analyzing EPIC array, `IlluminaHumanMethylationEPICanno.ilm10b4.hg19` needs 
to be loaded.
```{r eval = FALSE}
library(IlluminaHumanMethylationEPICanno.ilm10b4.hg19)
```

If analyzing user-supplied mapping between CpG ID and gene name, neither
`IlluminaHumanMethylation450kanno.ilmn12.hg19` nor 
`IlluminaHumanMethylationEPICanno.ilm10b4.hg19` needs to be loaded.


## Introduction

The methylGSA package contains functions to carry out gene set analysis 
adjusting for the number of CpGs per gene. It has been shown by 
Geeleher et al [1] that gene set analysis is extremely biased for DNA 
methylation data. This package contains three main functions to adjust for the 
bias in gene set analysis. 

* methylglm: Incorporating number of CpGs as a covariate in 
logistic regression. 

* methylRRA: Adjusting for multiple p-values of each gene by Robust 
Rank Aggregation [2], and then apply either 
over-representation analysis (ORA) or Preranked version of Gene Set Enrichment 
Analysis (GSEAPreranked) [3] in gene set testing. 

* methylgometh: Adjusting the number of CpGs for each gene by 
weighted resampling and Wallenius non-central hypergeometric approximation 
(via missMethyl [4]).

## Supported gene sets and gene ID types

* Gene Ontology (via org.Hs.eg.db [5])
* KEGG (via org.Hs.eg.db [5])
* Reactome (via reactome.db [6])
* User-supplied gene sets. Supported gene input ID types:
    + "SYMBOL"
    + "ENSEMBL"
    + "ENTREZID"
    + "REFSEQ"
    
## Supported array types

* Infinium Human Methylation 450K BeadChip 
(via IlluminaHumanMethylation450kanno.ilmn12.hg19 [7])
* Infinium Methylation EPIC BeadChip 
(via IlluminaHumanMethylationEPICanno.ilm10b4.hg19 [8])
* User supplied mapping between CpG ID and gene name

## Description of methylglm

methylglm is an extention of GOglm [9]. GOglm adjusts 
length bias for RNA-Seq data by incorporating gene length as a covariate 
in logistic regression model. methylglm adjusts length bias in DNA methylation 
by the number of CpGs instead of gene length. For each gene set, we fit a 
logistic regression model:

$$ \text{logit} (\pi_{i}) = \beta_{0} + \beta_{1}x_{i} + \beta_{2}c_{i}$$
For each gene $i$, $\pi_{i}$ = Pr(gene $i$ is in gene set), $x_{i}$ represents 
negative logarithmic transform of its minimum p-value in differential 
methylation analysis, and $c_{i}$ is logarithmic transform of its number 
of CpGs. 

methylglm requires only a simple named vector. This vector contains p-values of 
each CpG. Names should be their corresponding CpG IDs. 

### Example

Here is what the input vector looks like:

```{r}
data(cpgtoy)
head(cpg.pval, 20)
```

Please note that the p-values presented here in `cpg.pval` is for illustration 
purpose only. They are used to show how to utilize the functions in methylGSA. 
It does not represent p-values from any real data analysis. 
The actual p-values in differential methylation analysis may be quite 
different from the p-values in `cpg.pval` in terms of the magnitude.    

Run methylglm:

```{r}
res1 = methylglm(cpg.pval = cpg.pval, minsize = 200, 
                 maxsize = 500, GS.type = "KEGG")
head(res1, 15)
```

Result is a data frame ranked by p-values of gene sets. The meaning of each
column is given below.

```{r echo=FALSE}
glm_res = data.frame(
    "Column" = c("ID", 
                 "Description (N/A for user supplied gene set)",
                 "Size", "pvalue", "padj"),
    "Explanation" = c("Gene set ID", "Gene set description", 
                "Number of genes in gene set", 
                "p-value in logistic regression", "Adjusted p-value")
)
knitr::kable(glm_res)
```

Bioconductor package
[org.Hs.eg.db](
https://bioconductor.org/packages/data/annotation/html/org.Hs.eg.db.html)
can be used to pull out the genes corresponding a specific pathway. 
For instance, one of the pathways in the methylglm output above is 
"Neuroactive ligand-receptor interaction" with KEGG ID 04080. The following 
code can be used to obtain its genes.

```{r}
library(org.Hs.eg.db)
genes_04080 = select(org.Hs.eg.db, "04080", "SYMBOL", keytype = "PATH")
head(genes_04080)
```

The following code can be used to get the genes in all the pathways in 
methylglm output.

```{r eval=FALSE}
# include all the IDs as the 2nd argument in select function
genes_all_pathway = select(org.Hs.eg.db, as.character(res1$ID), 
                     "SYMBOL", keytype = "PATH")
head(genes_all_pathway)
```


## Description of methylRRA

Robust rank aggregation [2] is a parameter free model that 
aggregates several ranked gene lists into a single gene list. The aggregation 
assumes random order of input lists and assign each gene a p-value based on 
order statistics. We apply this order statistics idea to adjust for number 
of CpGs. 

For gene $i$, let $P_{1}, P_{2}, ... P_{n}$ be the p-values of individual CpGs 
in differential methylation analysis. 
Under the null hypothesis, 
$P_{1}, P_{2}, ... P_{n} ~ \overset{i.i.d}{\sim} Unif[0, 1]$. 
Let $P_{(1)}, P_{(2)}, ... P_{(n)}$ be the order statistics. Define: 
$$\rho = 
\text{min}\{\text{Pr}(P_{(1)}<P_{(1)\text{obs}}), 
\text{Pr}(P_{(2)}<P_{(2)\text{obs}})..., 
\text{Pr}(P_{(n)}<P_{(n)\text{obs}}) \} $$

methylRRA supports two approaches to adjust for number of CpGs, ORA and 
GSEAPreranked [3]. In ORA approach, for gene $i$, conversion from 
$\rho$ score into p-value is done by Bonferroni correction [2]. 
We get a p-value for each gene and these p-values are then corrected for 
multiple testing use Benjamini & Hochberg procedure 
[10]. By default, genes with False Discovery Rate (FDR) below 0.05 are 
considered differentially expressed (DE) genes. If there are
no DE genes under FDR 0.05, users are able to use `sig.cut` option to specify
a higher FDR cut-off or `topDE` option to declare top genes to be 
differentially expressed. We then apply ORA based on these DE genes. 

In GSEAPreranked approach, for gene $i$, we also convert $\rho$ score into 
p-value by Bonferroni correction. p-values are converted into z-scores. We then 
apply Preranked version of Gene Set Enrichment Analysis (GSEAPreranked) on 
the gene list ranked by the z-scores.  

### Example

To apply ORA approach, we use argument `method = "ORA"` (default) in methylRRA

```{r eval=FALSE}
res2 = methylRRA(cpg.pval = cpg.pval, method = "ORA", 
                    minsize = 200, maxsize = 210)
head(res2, 15)
```

The meaning of each column in the output is given below.

```{r echo=FALSE}
ora_res = data.frame(
    "Column" = c("ID", 
                 "Description (N/A for user supplied gene set)", "Count",
                 "overlap", "Size", "pvalue", "padj"),
    "Explanation" = c("Gene set ID", "Gene set description", 
                "Number of significant genes in the gene set",
                "Names of significant genes in the gene set",
                "Number of genes in gene set", 
                "p-value in ORA", "Adjusted p-value")
)
knitr::kable(ora_res)
```


To apply GSEAPreranked approach, we use argument `method = "GSEA"` in methylRRA

```{r eval=FALSE}
res3 = methylRRA(cpg.pval = cpg.pval, method = "GSEA", 
                    minsize = 200, maxsize = 210)
head(res3, 10)
```

The meaning of each column in the output is given below.

```{r echo=FALSE}
gsea_res = data.frame(
    "Column" = c("ID", 
                 "Description (N/A for user supplied gene set)", 
                 "Size", "enrichmentScore", "NES",
                 "pvalue", "padj"),
    "Explanation" = c("Gene set ID", "Gene set description", 
                "Number of genes in gene set",
                "Enrichment score (see [3] for details)", 
                "Normalized enrichment score (see [3] for details)",
                "p-value in GSEA", "Adjusted p-value")
)
knitr::kable(gsea_res)
```


## Description of methylgometh

methylgometh calls `gometh` or `gsameth` function in missMethyl 
package [4] to adjust number of CpGs in gene set 
testing. `gometh` modifies goseq method [11] by fitting a 
probability weighting function and resampling from Wallenius non-central 
hypergeometric distribution. 

methylgometh requires two inputs, `cpg.pval` and `sig.cut`. `sig.cut` specifies
the cut-off point to declare a CpG as differentially methylated. By default, 
`sig.cut` is 0.001. Similar to methylRRA, if no CpG is significant, users are 
able to specify a higher cut-off or use `topDE` option to declare 
top CpGs to be differentially methylated.

### Example

```{r eval=FALSE}
res4 = methylgometh(cpg.pval = cpg.pval, sig.cut = 0.001, 
                        minsize = 200, maxsize = 210)
head(res4, 15)
```


## Other options

methylGSA provides many other options for users to customize the analysis. 

* `array.type` is to specify which array type to use. It is either "450K" or 
"EPIC". Default is "450K". This argument will be ignored if `FullAnnot` is 
provided.
* `FullAnnot` is preprocessed mapping between CpG ID and gene name provided by
prepareAnnot function. Default is NULL. Check example below for details. 
* `group` is the type of CpG to be considered in methylRRA or methylglm. By 
default, `group` is "all", which means all CpGs are considered regardless 
of their gene group. If `group` is "body", only CpGs on gene body will be 
considered. If `group` is "promoter1" or "promoter2", only CpGs on promoters 
will be considered. Based on the annotation in 
IlluminaHumanMethylation450kanno.ilmn12.hg19 and 
IlluminaHumanMethylationEPICanno.ilm10b4.hg19, "body", "promoter1" and 
"promoter2" are defined as: 
    + body: CpGs whose gene group correspond to "Body" or "1stExon" 
    + promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
    + promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
      "1stExon", or "5'UTR"    
* `GS.list` is user supplied gene sets to be tested. It should be a list with 
entry names gene set IDs and elements correpond to genes that gene set 
contain. If there is no input list, Gene Ontology is used by default.
* `GS.idtype` is the type of gene ID in user supplied gene sets. If `GS.list` 
is not empty, then the user is expected to provide gene ID type. Supported ID 
types are "SYMBOL", "ENSEMBL", "ENTREZID", "REFSEQ". Default is "SYMBOL". 
* `GS.type` is the published gene sets/pathways to be tested if `GS.list` is 
empty. Supported pathways are "GO" (Gene Ontology), "KEGG", and "Reactome". 
Default is "GO".
* `minsize` is an integer. If the number of genes in a gene set is less than 
this integer, this gene set is not tested. Default is 100.
* `maxsize` is also an integer. If the number of genes in a gene set is 
greater than this integer, this gene set is not tested. Default is 500.
* In methylRRA, `method` is to specify gene set test method. It is either 
"ORA" or "GSEA" as described in the previous section. Default is "ORA".
* In methylglm, `parallel` is either `TRUE` or `FALSE` indicating whether 
parallel should be used. Default is `FALSE`.

### Examples

An example of user supplied gene sets is given below. The gene ID type is 
gene symbol.
```{r}
data(GSlisttoy)
## to make the display compact, only a proportion of each gene set is shown
head(lapply(GS.list, function(x) x[1:30]), 3)   
```

Below is an example of running methylglm with parallel option
```{r eval=FALSE}
library(BiocParallel)
res_p = methylglm(cpg.pval = cpg.pval, minsize = 200, 
                  maxsize = 500, GS.type = "KEGG", parallel = TRUE)
```

methylglm and methylRRA support user supplied CpG ID to gene mapping. The 
mapping is expected to be a matrix, or a data frame or a list. For a 
matrix or data frame, 1st column should be CpG ID and 2nd column should be gene 
name. For a list, entry names should be gene names and elements correpond to 
CpG IDs. Below an example of user supplied CpG to gene mapping.
```{r}
data(CpG2Genetoy)
head(CpG2Gene)   
```

To use user supplied mapping in methylglm or methylRRA, first preprocess the
mapping by prepareAnnot function
```{r}
FullAnnot = prepareAnnot(CpG2Gene) 
```

Test the gene sets using "ORA" in methylRRA, use `FullAnnot` argument to 
provide the preprocessed CpG ID to gene mapping
```{r}
GS.list = GS.list[1:10]
res5 = methylRRA(cpg.pval = cpg.pval, FullAnnot = FullAnnot, method = "ORA", 
                    GS.list = GS.list, GS.idtype = "SYMBOL", 
                    minsize = 100, maxsize = 300)
head(res5, 10)
```

Below is another example testing Reactome pathways using methylglm.

```{r eval=FALSE}
res6 = methylglm(cpg.pval = cpg.pval, array.type = "450K", 
                    GS.type = "Reactome", minsize = 100, maxsize = 110)
head(res6, 10)
```

## Visualization

Following bar plot implemented in enrichplot [12], we also provide bar plot to 
visualize the gene set analysis results. The input of `barplot` function can 
be any result returned by methylglm, methylRRA, or methylgometh. Various 
options are provided for users to customize the plot.

* `xaxis` is to specify the label in x-axis. It is either "Count" 
(number of significant genes in gene set) or "Size" (total number of genes 
in gene set). "Count" option is not available for methylglm and 
methylRRA(GSEA). Default is "Size".
* `num` is to specify the number of genes sets to display on the bar plot.
Default is 5.
* `colorby` is a string. Either "pvalue" or "padj". Default is "padj".
* `title` is a string. The title to display on the bar plot. Default is NULL. 

### Example

Below is an example of using barplot to visualize the result of methylglm.
```{r}
barplot(res1, num = 8, colorby = "pvalue")
```


## Session info

```{r sessionInfo}
sessionInfo()
```


## References
[1] Geeleher, Paul, Lori Hartnett, Laurance J Egan, Aaron Golden, 
Raja Affendi Raja Ali, and Cathal Seoighe. 2013. Gene-Set Analysis Is 
Severely Biased When Applied to Genome-Wide Methylation Data.
Bioinformatics 29 (15). Oxford University Press: 1851–7.

[2] Kolde, Raivo, Sven Laur, Priit Adler, and Jaak Vilo. 2012. 
Robust Rank Aggregation for Gene List Integration and Meta-Analysis. 
Bioinformatics 28 (4). Oxford University Press: 573–80.

[3] Subramanian, Aravind, Pablo Tamayo, Vamsi K Mootha, Sayan Mukherjee, 
Benjamin L Ebert, Michael A Gillette, Amanda Paulovich, et al. 2005. 
Gene Set Enrichment Analysis: A Knowledge-Based Approach for Interpreting 
Genome-Wide Expression Profiles. Proceedings of the National Academy of 
Sciences 102 (43). National Acad Sciences: 15545–50.

[4] Phipson, Belinda, Jovana Maksimovic, and Alicia Oshlack. 2015. 
MissMethyl: An R Package for Analyzing Data from Illumina's Humanmethylation450 
Platform. Bioinformatics 32 (2). Oxford University Press: 286–88.

[5] Carlson M (2018). org.Hs.eg.db: Genome wide annotation for Human. 
R package version 3.6.0.

[6] Ligtenberg W (2018). reactome.db: A set of annotation maps for reactome. 
R package version 1.64.0.

[7] Hansen, KD. (2016). IlluminaHumanMethylation450kanno.ilmn12.hg19: 
Annotation for Illumina’s 450k Methylation Arrays. R Package, Version 0.6.0 1.

[8] Hansen, KD. (2017). IlluminaHumanMethylationEPICanno.ilm10b4.hg19: 
Annotation for Illumina’s Epic Methylation Arrays. R Package, Version 0.6.0 1.

[9] Mi, Gu, Yanming Di, Sarah Emerson, Jason S Cumbie, and Jeff H Chang. 2012. 
Length Bias Correction in Gene Ontology Enrichment Analysis Using 
Logistic Regression. PloS One 7 (10). Public Library of Science: e46128.

[10] Benjamini, Yoav, and Yosef Hochberg. 1995. Controlling the False 
Discovery Rate: A Practical and Powerful Approach to Multiple Testing.
Journal of the Royal Statistical Society. Series B (Methodological). 
JSTOR, 289–300.

[11] Young, Matthew D, Matthew J Wakefield, Gordon K Smyth, and Alicia 
Oshlack. 2012. Goseq: Gene Ontology Testing for Rna-Seq Datasets.
R Bioconductor.

[12] Yu G (2018). enrichplot: Visualization of Functional Enrichment Result. 
R package version 1.0.2, https://github.com/GuangchuangYu/enrichplot.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGS.R
\name{getGS}
\alias{getGS}
\title{Get Gene Sets}
\usage{
getGS(geneids, GS.type)
}
\arguments{
\item{geneids}{A vector contains all gene ids of interest. Gene ids should
be gene symbol.}

\item{GS.type}{A string. "GO", "KEGG", or "Reactome".}
}
\value{
A list contains all gene sets of
interest and their corresponding genes.
}
\description{
This function gets gene sets information.
}
\examples{
geneids = c("FKBP5", "NDUFA1", "STAT5B")
GO.list = getGS(geneids, "KEGG")
head(GO.list)
}
\references{
Carlson M (2017). org.Hs.eg.db:
Genome wide annotation for Human. R package version 3.5.0.

Ligtenberg W (2017). reactome.db:
A set of annotation maps for reactome. R package version 1.62.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runExample.R
\name{runExample}
\alias{runExample}
\title{methylGSA shiny app}
\usage{
runExample(run = TRUE)
}
\arguments{
\item{run}{Run the app or not. Default is TRUE}
}
\value{
The shiny app will be opened in a web browser.
}
\description{
This is an interface for Bioconductor package methylGSA.
}
\note{
In order to run the app, the following R/Bioconductor packages needs
to be installed properly: shinycssloaders, DT, ggplot2, 
IlluminaHumanMethylation450kanno.ilmn12.hg19 (if analyzing 450K array)
IlluminaHumanMethylationEPICanno.ilm10b4.hg19 (if analyzing EPIC array)
}
\examples{
## Please note: in this example, the argument run is set to be FALSE in 
## order to pass R CMD check. However, when using the app, users are 
## expected to launch the app by runExample()
runExample(FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barplot.R
\name{barplot}
\alias{barplot}
\title{Barplot for methylGSA analysis result}
\usage{
barplot(res, xaxis = "Size", num = 5, colorby = "padj", title = "")
}
\arguments{
\item{res}{A data frame which contains methylGSA analysis result.}

\item{xaxis}{A string which specify the x-axis in the barplot. 
Either "Size" (number of genes in gene set) or "Count" 
(number of significant genes in gene set). Default is "Size". "Count" option
is not available for methylglm and methylRRA(GSEA) result.}

\item{num}{An integer. Number of gene sets to display on the barplot. 
Default is 5.}

\item{colorby}{A string. Either "pvalue" or "padj". Default is "padj".}

\item{title}{A string. Barplot title. Default is NULL.}
}
\value{
ggplot object
}
\description{
This function visualizes methylGSA analysis result by barplot.
}
\details{
The implementation of the function is adapted from barplot function
in enrichplot package.
}
\examples{
res = data.frame(ID = c("04144", "04510", "04740", "04810", "05200"),
                 Description = c("Endocytosis", "Focal adhesion", 
                 "Olfactory transduction", 
                 "Regulation of actin cytoskeleton", "Pathways in cancer"),
                 Size = c(201, 200, 388, 213, 326),
                 pvalue = c(0.481, 0.696, 1, 1, 1),
                 padj = 1
                 )
barplot(res)
}
\references{
Yu G (2018). enrichplot: Visualization of Functional Enrichment 
Result. R package version 1.0.2, https://github.com/GuangchuangYu/enrichplot.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylgometh.R
\name{methylgometh}
\alias{methylgometh}
\title{Adjusting number of probes in gene set testing
using gometh or gsameth in missMethyl}
\usage{
methylgometh(cpg.pval, sig.cut = 0.001, topDE = NULL,
  array.type = "450K", GS.list = NULL, GS.idtype = "SYMBOL",
  GS.type = "GO", minsize = 100, maxsize = 500)
}
\arguments{
\item{cpg.pval}{A named vector containing p-values of
differential methylation test. Names should be CpG IDs.}

\item{sig.cut}{A numeric value indicating cut-off value for significant CpG.
Default is 0.001. This argument will be ignored if topDE is provided.}

\item{topDE}{An integer. The top number of CpGs to be declared as 
significant.}

\item{array.type}{A string. Either "450K" or "EPIC". Default is "450K".}

\item{GS.list}{A list. Default is NULL. If there is no input list,
Gene Ontology is used. Entry names are gene sets names, and elements
correpond to genes that gene sets contain.}

\item{GS.idtype}{A string. "SYMBOL", "ENSEMBL", "ENTREZID" or "REFSEQ".
Default is "SYMBOL".}

\item{GS.type}{A string. "GO", "KEGG", or "Reactome"}

\item{minsize}{An integer. If the number of genes in a gene set
is less than this integer, this gene set is not tested. Default is 100.}

\item{maxsize}{An integer. If the number of genes in a gene set
is greater than this integer, this gene set is not tested. Default is 500.}
}
\value{
A data frame contains gene set tests results.
}
\description{
This function calls gometh or gsameth function
in missMethyl package to adjust number of probes in gene set testing
}
\examples{
\dontrun{
library(IlluminaHumanMethylation450kanno.ilmn12.hg19)
data(cpgtoy)
res = methylgometh(cpg.pval = cpg.pval, sig.cut = 0.001, GS.type = "KEGG",
minsize = 200, maxsize = 205)
head(res)
}
}
\references{
Phipson, B., Maksimovic, J., and Oshlack, A. (2015).
missMethyl: an R package for analysing methylation data from Illuminas
HumanMethylation450 platform. Bioinformatics, btv560.

Ligtenberg W (2017). reactome.db: A set of annotation maps
for reactome. R package version 1.62.0.

Carlson M (2017). org.Hs.eg.db: Genome wide annotation
for Human. R package version 3.5.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/toydatasets.R
\docType{data}
\name{cpg.pval}
\alias{cpg.pval}
\title{An example of user input cpg.pval}
\format{A named vector contains p-values of each probe tested}
\usage{
cpg.pval
}
\description{
An example of user input cpg.pval
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDescription.R
\name{getDescription}
\alias{getDescription}
\title{Get gene set description}
\usage{
getDescription(GSids, GS.type)
}
\arguments{
\item{GSids}{A vector contains gene set IDs.}

\item{GS.type}{A string. "GO", "KEGG", or "Reactome".}
}
\value{
A vector contains gene sets description.
}
\description{
This function gets description of gene sets.
}
\examples{
GSids = c("GO:0007389", "GO:0000978", "GO:0043062")
Description = getDescription(GSids, "GO")
head(Description)
}
\references{
Carlson M (2018). GO.db: A set of annotation maps describing 
the entire Gene Ontology. R package version 3.6.0.

Yu G, Wang L, Han Y, He Q (2012). clusterProfiler: an R package 
for comparing biological themes among gene clusters. OMICS: A Journal 
of Integrative Biology, 16(5), 284-287.

Ligtenberg W (2017). reactome.db:
A set of annotation maps for reactome. R package version 1.62.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylRRA.R
\name{methylRRA}
\alias{methylRRA}
\title{Enrichment analysis after adjusting multiple p-values of
each gene by Robust Rank Aggregation}
\usage{
methylRRA(cpg.pval, array.type = "450K", FullAnnot = NULL,
  group = "all", method = "ORA", sig.cut = 0.05, topDE = NULL,
  GS.list = NULL, GS.idtype = "SYMBOL", GS.type = "GO",
  minsize = 100, maxsize = 500)
}
\arguments{
\item{cpg.pval}{A named vector containing p-values of differential
methylation test. Names should be CpG IDs.}

\item{array.type}{A string. Either "450K" or "EPIC". Default is "450K".
This argument will be ignored if FullAnnot is provided.}

\item{FullAnnot}{A data frame provided by prepareAnnot function.
Default is NULL.}

\item{group}{A string. "all", "body", "promoter1" or "promoter2". 
Default is "all". If group = "body", only CpGs on gene body will be 
considered in methylRRA. If group = "promoter1" or group = "promoter2", 
only CpGs on promoters will be considered. Here is the definition of "body", 
"promoter1" and "promoter2" according to the annotation in 
IlluminaHumanMethylation450kanno.ilmn12.hg19 or 
IlluminaHumanMethylationEPICanno.ilm10b4.hg19. 
\itemize{
  \item body: CpGs whose gene group correspond to "Body" or "1stExon" 
  \item promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
  \item promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
  "1stExon", or "5'UTR". 
}
If group = "all", all CpGs are considered regardless of their gene group.}

\item{method}{A string. "ORA" or "GSEA". Default is "ORA"}

\item{sig.cut}{A numeric value indicating FDR cut-off for significant gene
in ORA. Default is 0.05. This argument will be ignored if topDE is provided
or method = "GSEA" is used.}

\item{topDE}{An integer. The top number of genes to be declared as 
significant after robust rank aggregation. This argument will be ignored
if method = "GSEA" is used.}

\item{GS.list}{A list. Default is NULL. If there is no input list,
Gene Ontology is used. Entry names are gene sets names, and elements
correpond to genes that gene sets contain.}

\item{GS.idtype}{A string. "SYMBOL", "ENSEMBL", "ENTREZID" or
"REFSEQ". Default is "SYMBOL".}

\item{GS.type}{A string. "GO", "KEGG", or "Reactome". Default is "GO"}

\item{minsize}{An integer. If the number of genes in a gene set is
less than this integer, this gene set is not tested. Default is 100.}

\item{maxsize}{An integer. If the number of genes in a gene set is
greater than this integer, this gene set is not tested. Default is 500.}
}
\value{
A data frame contains gene set tests results.
}
\description{
This function implements enrichment after adjusting
multiple p-values of each gene by Robust Rank Aggregation.
}
\examples{
data(CpG2Genetoy)
data(cpgtoy)
data(GSlisttoy)
GS.list = GS.list[1:10]
FullAnnot = prepareAnnot(CpG2Gene)
res1 = methylRRA(cpg.pval = cpg.pval, FullAnnot = FullAnnot,
method = "ORA", GS.list = GS.list)
head(res1)
}
\references{
Kolde, Raivo, et al. Robust rank aggregation for gene
list integration and meta-analysis. Bioinformatics 28.4 (2012): 573-580.

Phipson, B., Maksimovic, J., and Oshlack, A. (2015).
missMethyl: an R package for analysing methylation data from Illuminas
HumanMethylation450 platform. Bioinformatics, btv560.

Yu, Guangchuang, et al. clusterProfiler: an R package for
comparing biological themes among gene clusters. Omics: a journal of
integrative biology 16.5 (2012): 284-287.

Carlson M (2017). org.Hs.eg.db: Genome wide annotation for
Human. R package version 3.5.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/toydatasets.R
\docType{data}
\name{GS.list}
\alias{GS.list}
\title{An example of user input gene sets}
\format{A list contains user input gene set
names and their corresponding genes}
\usage{
GS.list
}
\description{
An example of user input gene sets
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/toydatasets.R
\docType{data}
\name{CpG2Gene}
\alias{CpG2Gene}
\title{An example of user user-supplied mapping between CpGs and genes}
\format{A data frame contains mapping between CpGs and genes}
\usage{
CpG2Gene
}
\description{
An example of user user-supplied mapping between CpGs and genes
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepareAnnot.R
\name{prepareAnnot}
\alias{prepareAnnot}
\title{Prepare user-supplied mapping between CpGs and genes.}
\usage{
prepareAnnot(CpG2Gene, geneidtype = "SYMBOL")
}
\arguments{
\item{CpG2Gene}{A matrix, or a data frame or a list contains CpG to gene
mapping. For a matrix or data frame, 1st column should be CpG ID and 2nd
column should be gene name. For a list, entry names should be gene names,
and elements correpond to CpG IDs.}

\item{geneidtype}{A string. "SYMBOL", "ENSEMBL", "ENTREZID" or "REFSEQ".
Default is "SYMBOL".}
}
\value{
A data frame contains ready to use CpG to gene mapping.
}
\description{
This function prepares CpG to gene mapping which will be
used by methylRRA and methylglm.
}
\examples{
data(CpG2Genetoy)
FullAnnot = prepareAnnot(CpG2Gene)
head(FullAnnot)
}
\references{
Carlson M (2017). org.Hs.eg.db:
Genome wide annotation for Human. R package version 3.5.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAnnot.R
\name{getAnnot}
\alias{getAnnot}
\title{Get CpG annotation}
\usage{
getAnnot(array.type, group = "all")
}
\arguments{
\item{array.type}{A string. Either "450K" or "EPIC". Default is "450K".}

\item{group}{A string. "all", "body", "promoter1" or "promoter2". 
Default is "all". If group = "body", only CpGs on gene body will be 
pulled out. If group = "promoter1" or group = "promoter2", 
only CpGs on promoters will be pulled out. Here is the definition of "body", 
"promoter1" and "promoter2" according to the annotation in 
IlluminaHumanMethylation450kanno.ilmn12.hg19 or 
IlluminaHumanMethylationEPICanno.ilm10b4.hg19. 
\itemize{
  \item body: CpGs whose gene group correspond to "Body" or "1stExon" 
  \item promoter1: CpGs whose gene group correspond to "TSS1500" or "TSS200"
  \item promoter2: CpGs whose gene group correspond to "TSS1500", "TSS200", 
  "1stExon", or "5'UTR". 
}
If group = "all", all CpGs will be pulled out.}
}
\value{
A data frame contains CpG IDs and gene symbols.
}
\description{
This function gets CpG IDs and their corresponding gene symbols.
}
\details{
The implementation of the function is modified
from .flattenAnn function in missMethyl package.
}
\references{
Hansen KD (2016). IlluminaHumanMethylation450kanno.ilmn12.hg19:
Annotation for Illumina's 450k methylation arrays. R package version 0.6.0.

Hansen KD (2017). IlluminaHumanMethylationEPICanno.ilm10b4.hg19:
Annotation for Illumina's EPIC methylation arrays. R package version 0.6.0,
https://bitbucket.com/kasperdanielhansen/Illumina_EPIC.

Phipson B, Maksimovic J and Oshlack A (2015).
“missMethyl: an R package for analysing methylation data from
Illuminas HumanMethylation450 platform.” Bioinformatics, pp. btv560.
}
